import csv
from collective.csv2dict import BaseCSVReader, to_string


class ApoDialect(csv.excel):
    delimiter = ';'

csv.register_dialect('apodialect', ApoDialect)


class ApothecaryCSVReader(BaseCSVReader):
    """Apothecary csv reader class.

    """
    dialect = 'apodialect'
    encoding = 'iso8859'
    fields = [
        # The format is: (field name, filter method)
        ('nawnr_apotheker', to_string),
        ('sorteer_naam', to_string),
        ('naam', to_string),
        ('voorletters', to_string),
        ('titulatuur', to_string),
        ('geslacht', to_string),
        ('hoofd_functiecode', to_string),
        ('nawnr_apotheek', to_string),
        ('naam_apotheek', to_string),
        ('tav', to_string),
        ('adres_apotheek', to_string),
        ('postcode_apotheek', to_string),
        ('plaats_apotheek', to_string),
        ('postbus_apotheek', to_string),
        ('postcode_postbus_apotheek', to_string),
        ('postbus_plaats_apotheek', to_string),
        ('land_apotheek', to_string),
        ('telefoonnummer', to_string),
        ('faxnummer', to_string),
        ('email', to_string),
        ('district_apotheek', to_string),
        ('adres_apotheker', to_string),
        ('postcode_apotheker', to_string),
        ('plaats_apotheker', to_string),
        ('postbus_apotheker', to_string),
        ('postcode_postbus_apotheker', to_string),
        ('postbus_plaats_apotheker', to_string),
        ('land_apotheker', to_string),
        ('telefoon_apotheker', to_string),
        ('faxnummer_apotheker', to_string),
        ('email_apotheker', to_string),
        ('district_apotheker', to_string),
        ('lid_knmp', to_string),
        ('lid_vja', to_string),
        ('achtervoegsel', to_string),
        ('soort_lid', to_string),
        ('functie', to_string),
        ('soort_apotheek', to_string),
    ]
