# -*- coding: utf-8 -*-

import os.path
from plone.app.testing import FunctionalTesting
from plone.app.testing import IntegrationTesting
from plone.app.testing import PLONE_FIXTURE
from plone.app.testing import PloneSandboxLayer


def get_file_upload(filename):
    here = os.path.dirname(__file__)
    filepath = os.path.join(here, 'tests', 'data', filename)
    return open(filepath).read(), 'text/plain', filename


class BasicFixture(PloneSandboxLayer):

    defaultBases = (PLONE_FIXTURE,)

    def setUpZope(self, app, configurationContext):
        # Load ZCML
        import collective.csvsearcher
        self.loadZCML(package=collective.csvsearcher)


BASIC_FIXTURE = BasicFixture()
BASIC_FUNCTIONAL_TESTING = FunctionalTesting(
    bases=(BASIC_FIXTURE,),
    name='collective.csvsearcher:BasicFunctional',
)
BASIC_INTEGRATION_TESTING = IntegrationTesting(
    bases=(BASIC_FIXTURE,),
    name='collective.csvsearcher:BasicIntegration',
)
