from collective.csvsearcher.interfaces import IStorage
from zope.interface import implements
from zope.schema.interfaces import IVocabularyFactory
from zope.schema.vocabulary import SimpleTerm, SimpleVocabulary


class StorageVocabulary(object):
    implements(IVocabularyFactory)

    def __init__(self, name):
        # storage property from which to take the values
        self.property = name

    def __call__(self, context):
        storage = IStorage(context, None)
        if storage is None:
            return SimpleVocabulary([])
        return SimpleVocabulary.fromValues(
            getattr(storage, self.property))

DistrictVocabularyFactory = StorageVocabulary('districts')
# Membership:
SoortLidVocabularyFactory = StorageVocabulary('soort_lid')


class SortOnVocabularyFactory(object):
    implements(IVocabularyFactory)

    def __call__(self, context):
        # Somehow the message factory does not get picked up here, so we
        # do not use _('Field name').
        terms = [
            ('sorteer_naam', u'Naam'),
            ('plaats_apotheker', u'Woonplaats'),
            ('naam_apotheek', u'Apotheek'),
            ('plaats_apotheek', u'Vestigingsplaats'),
            ('district_apotheek', u'District'),
        ]
        terms = [SimpleTerm(value, title=title) for value, title in terms]
        return SimpleVocabulary(terms)

SortOnVocabulary = SortOnVocabularyFactory()
